// FtpClientDlg.h : header file
//

#pragma once

#include "..\..\..\Source\IrDA\wclIrDADevices.h"
#include "..\..\..\Source\IrDA\wclIrDAClients.h"
#include "..\..\..\Source\Communication\wclObex.h"


using namespace wclCommon;
using namespace wclCommunication;
using namespace wclIrDA;

// CFtpClientDlg dialog
class CFtpClientDlg : public CDialog
{
// Construction
public:
	CFtpClientDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_FTPCLIENT_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

private:
	CListCtrl lvDevices;
	CEdit edFileName;
	CProgressCtrl ProgressBar;
	CEdit edNewDirName;
	CListCtrl lvFiles;
	CListBox lbLog;

private:
	CwclIrDAReceiver wclIrDAReceiver;
	CwclIrDAClient wclIrDAClient;
	CwclObexFtpClient* FFtp;

	void ClientDisconnect(void* Sender, const int Reason);
	void ClientConnect(void* Sender, const int Error);
	void ClientDestroyProcessor(void* Sender, CwclClientDataConnection* const Connection);
	void ClientCreateProcessor(void* Sender, CwclClientDataConnection* const Connection);

	void FtpConnect(void* Sender, const int Error, const tstring& Description);
	void FtpDisconnect(void* Sender, const int Error, const tstring& Description);
	void FtpPutComplete(void* Sender, const int Error, const tstring& Description, 
		CwclStream* const Stream);
	void FtpProgress(void* Sender, const unsigned long Size, const unsigned long Position);
	void FtpGetComplete(void* Sender, const int Error, const tstring& Description, 
		CwclStream* const Stream);
	void FtpDirComplete(void* Sender, const int Error, const tstring& Description, 
		const wclObexFileObjects& Dirs);
	void FtpChangeDirComplete(void* Sender, const int Error, const tstring& Description);
	void FtpDeleteComplete(void* Sender, const int Error, const tstring& Description);
	void FtpMakeDirComplete(void* Sender, const int Error, const tstring& Description);

public:
	afx_msg void OnBnClickedButtonClear();
	afx_msg void OnDestroy();
	afx_msg void OnBnClickedButtonDiscover();
	afx_msg void OnBnClickedButtonDisconnect();
	afx_msg void OnBnClickedButtonCloseSession();
	afx_msg void OnBnClickedButtonOpenSession();
	afx_msg void OnBnClickedButtonConnect();
	afx_msg void OnBnClickedButtonSelectFile();
	afx_msg void OnBnClickedButtonAbort();
	afx_msg void OnBnClickedButtonSendFile();
	afx_msg void OnBnClickedButtonDir();
	afx_msg void OnNMDblclkListFiles(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedButtonRoot();
	afx_msg void OnBnClickedButtonDelete();
	afx_msg void OnBnClickedButtonMkDir();
};
