// IrDAClientDlg.h : header file
//

#pragma once
#include "afxcmn.h"
#include "afxwin.h"

#include "..\..\..\Source\IrDA\wclIrDAClients.h"

using namespace wclCommon;
using namespace wclIrDA;


// CIrDAClientDlg dialog
class CIrDAClientDlg : public CDialog
{
// Construction
public:
	CIrDAClientDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_IRDACLIENT_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

private:
	CListCtrl lvDevices;
	CEdit edText;
	CListBox lbEvents;
	CEdit edTimeout;
	CEdit edReadBuffer;
	CEdit edWriteBuffer;

	CwclIrDAClient wclIrDAClient;
	CwclIrDAReceiver wclIrDAReceiver;

	void ShowError(const int Error) const;
	
	void ClientConnect(void* Sender, const int Error);
	void ClientData(void* Sender, const void* const Data, const unsigned long Size);
	void ClientDisconnect(void* Sender, const int Reason);

public:
	afx_msg void OnBnClickedButtonDiscover();
	afx_msg void OnBnClickedButtonClear();
	afx_msg void OnBnClickedButtonDisconnect();
	afx_msg void OnBnClickedButtonConnect();
	afx_msg void OnBnClickedButtonSend();
	afx_msg void OnDestroy();
	afx_msg void OnBnClickedButtonSetBuffers();
};
