// IrDADiscoveryDlg.cpp : implementation file
//

#include "stdafx.h"
#include "IrDADiscovery.h"
#include "IrDADiscoveryDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CIrDADiscoveryDlg dialog




CIrDADiscoveryDlg::CIrDADiscoveryDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CIrDADiscoveryDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CIrDADiscoveryDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_DEVICES, lvDevices);
	DDX_Control(pDX, IDC_COMBO_CLASS_NAME, cbClassName);
	DDX_Control(pDX, IDC_COMBO_ATTRIBUTE_NAME, cbAttributeName);
	DDX_Control(pDX, IDC_LIST_EVENTS, lbEvents);
}

BEGIN_MESSAGE_MAP(CIrDADiscoveryDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_CBN_CLOSEUP(IDC_COMBO_CLASS_NAME, &CIrDADiscoveryDlg::OnCbnCloseupComboClassName)
	ON_BN_CLICKED(IDC_BUTTON_DISCOVER, &CIrDADiscoveryDlg::OnBnClickedButtonDiscover)
	ON_BN_CLICKED(IDC_BUTTON_QUERY, &CIrDADiscoveryDlg::OnBnClickedButtonQuery)
	ON_BN_CLICKED(IDC_BUTTON_SUBSCRIBE, &CIrDADiscoveryDlg::OnBnClickedButtonSubscribe)
	ON_BN_CLICKED(IDC_BUTTON_UNSUBSCRIBE, &CIrDADiscoveryDlg::OnBnClickedButtonUnsubscribe)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, &CIrDADiscoveryDlg::OnBnClickedButtonClear)
	ON_BN_CLICKED(IDC_BUTTON_START_LAZY_DISCOVERING, &CIrDADiscoveryDlg::OnBnClickedButtonStartLazyDiscovering)
	ON_BN_CLICKED(IDC_BUTTON_STOP_LAZY_DISCOVERING, &CIrDADiscoveryDlg::OnBnClickedButtonStopLazyDiscovering)
	ON_WM_DESTROY()
END_MESSAGE_MAP()


// CIrDADiscoveryDlg message handlers

BOOL CIrDADiscoveryDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	lvDevices.InsertColumn(0, _T("Address"), 0, 80);
	lvDevices.InsertColumn(1, _T("Name"), 0, 150);
	lvDevices.InsertColumn(2, _T("Hints"), 0, 250);
	lvDevices.InsertColumn(3, _T("CharSet"), 0, 80);
	lvDevices.SetExtendedStyle(lvDevices.GetExtendedStyle() | LVS_EX_FULLROWSELECT);

	cbClassName.InsertString(0, _T("Device"));
	cbClassName.InsertString(1, _T("IrDA:IrCOMM"));
	cbClassName.InsertString(2, _T("IrDA:IrOBEX"));
	cbClassName.InsertString(3, _T("IrLPT"));
	cbClassName.InsertString(4, _T("IrDAFramework"));
	cbClassName.SetCurSel(0);
	OnCbnCloseupComboClassName();

	__hook(&CwclIrDAReceiver::OnChange, &wclIrDAReceiver, &CIrDADiscoveryDlg::wclIrDAReceiverChange);
	__hook(&CwclIrDAReceiver::OnDevicesFound, &wclIrDAReceiver, &CIrDADiscoveryDlg::wclIrDAReceiverDevicesFound);

	__hook(&CwclPowerEventsMonitor::OnPowerStateChanged, &FPowerMonitor, &CIrDADiscoveryDlg::PowerStateChanged);

	FPowerMonitor.Open();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CIrDADiscoveryDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CIrDADiscoveryDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CIrDADiscoveryDlg::OnCbnCloseupComboClassName()
{
	// TODO: Add your control notification handler code here

	cbAttributeName.ResetContent();
	
	switch (cbClassName.GetCurSel())
	{
		case 0:
			cbAttributeName.InsertString(0, _T("DeviceName"));
			cbAttributeName.InsertString(1, _T("IrLMPSupport"));
			break;
		
		case 1:
			cbAttributeName.InsertString(0, _T("Parameters"));
			cbAttributeName.InsertString(1, _T("IrDA:IrLMP:LsapSel"));
			cbAttributeName.InsertString(2, _T("IrDA:TinyTP:LsapSel"));
			cbAttributeName.InsertString(3, _T("IrDA:InstanceName"));
			break;
		
		case 2:
			cbAttributeName.InsertString(0, _T("IrDA:TinyTP:LsapSel"));
			break;
		
		case 3:
			cbAttributeName.InsertString(0, _T("IrDA:IrLMP:LsapSel"));
			break;

		case 4:
			cbAttributeName.InsertString(0, _T("Integer value"));
			cbAttributeName.InsertString(0, _T("Octet Sequence"));
			cbAttributeName.InsertString(0, _T("User string"));
			break;
	}
	
	cbAttributeName.SetCurSel(0);
}

void CIrDADiscoveryDlg::ShowError(const int Error) const
{
	CString s;
	s.Format(_T("Error: 0x%.8X"), Error);
	AfxMessageBox(s);
}

void CIrDADiscoveryDlg::OnBnClickedButtonDiscover()
{
	lvDevices.DeleteAllItems();

	wclIrDADevices Devices;
	int Res = wclIrDAReceiver.Discover(Devices);
	if (Res != WCL_E_SUCCESS)
		ShowError(Res);
	else
		if (Devices.size() == 0)
			AfxMessageBox(_T("Nothing found"));
		else
			for (size_t i = 0; i < Devices.size(); i++)
			{
				wclIrDADevice Device = Devices[i];
				
				CString s;
				s.Format(_T("%.8X"), Device.Address);
				lvDevices.InsertItem((int)i, s);
				lvDevices.SetItemText((int)i, 1, Device.Name.c_str());
				
				CString Str = _T("[");
				wclIrDAHint j = ihPnp;
				while (j <= ihObex)
				{
					if (Device.Hints.find(j) != Device.Hints.end())
					{
						switch (j)
						{
							case ihPnp:
								Str += _T("ihPnp,");
								break;
							case ihPda:
								Str += _T("ihPda,");
								break;
							case ihComputer:
								Str += _T("ihComputer,");
								break;
							case ihPrinter:
								Str += _T("ihPrinter,");
								break;
							case ihModem:
								Str += _T("ihModem,");
								break;
							case ihFax:
								Str += _T("ihFax,");
								break;
							case ihLan:
								Str += _T("ihLan,");
								break;
							case ihTelephony:
								Str += _T("ihTelephony,");
								break;
							case ihFileServer:
								Str += _T("ihFileServer,");
								break;
							case ihComm:
								Str += _T("ihComm,");
								break;
							case ihMessage:
								Str += _T("ihMessage,");
								break;
							case ihHttp:
								Str += _T("ihHttp,");
								break;
							case ihObex:
								Str += _T("ihObex,");
								break;
							default:
								Str += _T("Unknown,");
								break;
						}
					}

					j = (wclIrDAHint)(int)(j + 1);
				}
				Str += _T("]");
				lvDevices.SetItemText((int)i, 2, Str);
				
				switch (Device.CharSet)
				{
					case csAscii:
						lvDevices.SetItemText((int)i, 3, _T("csAscii"));
						break;
					case csIso8859_1:
						lvDevices.SetItemText((int)i, 3, _T("csIso8859_1"));
						break;
					case csIso8859_2:
						lvDevices.SetItemText((int)i, 3, _T("csIso8859_2"));
						break;
					case csIso8859_3:
						lvDevices.SetItemText((int)i, 3, _T("csIso8859_3"));
						break;
					case csIso8859_4:
						lvDevices.SetItemText((int)i, 3, _T("csIso8859_4"));
						break;
					case csIso8859_5:
						lvDevices.SetItemText((int)i, 3, _T("csIso8859_5"));
						break;
					case csIso8859_6:
						lvDevices.SetItemText((int)i, 3, _T("csIso8859_6"));
						break;
					case csIso8859_7:
						lvDevices.SetItemText((int)i, 3, _T("csIso8859_7"));
						break;
					case csIso8859_8:
						lvDevices.SetItemText((int)i, 3, _T("csIso8859_8"));
						break;
					case csIso8859_9:
						lvDevices.SetItemText((int)i, 3, _T("csIso8859_9"));
						break;
					case csUnicode:
						lvDevices.SetItemText((int)i, 3, _T("csUnicode"));
						break;
					default:
						lvDevices.SetItemText((int)i, 3, _T("Unknown"));
						break;
				}
			}
}

void CIrDADiscoveryDlg::OnBnClickedButtonQuery()
{
	POSITION Pos = lvDevices.GetFirstSelectedItemPosition();
	if (Pos == NULL)
		AfxMessageBox(_T("Select device"));
	else
	{
		CString s = _T("0x") + lvDevices.GetItemText(lvDevices.GetNextSelectedItem(Pos), 0);
		unsigned long Addr = _tcstol(s.GetBuffer(), NULL, 16);
		CString ClassName;
		cbClassName.GetLBText(cbClassName.GetCurSel(), ClassName);
		CString AttributeName;
		cbAttributeName.GetLBText(cbAttributeName.GetCurSel(), AttributeName);
		wclIrDAAttribute Attrib;
		int Res = wclIrDAReceiver.QueryAttribute(Addr, tstring(ClassName), tstring(AttributeName), Attrib);
		if (Res != WCL_E_SUCCESS)
			ShowError(Res);
		else
		{
			switch (Attrib.ValueType)
			{
				case atInteger:
					s.Format(_T("%d"), Attrib.IntegerValue);
					AfxMessageBox(s);
					break;

				case atSequence:
					s = _T("");
					if (Attrib.SequenceValue.size() != 0)
					{
						for (size_t i = 0; i < Attrib.SequenceValue.size();  i++)
						{
							TCHAR buf[10];
							_itot_s(Attrib.SequenceValue[i], buf, 10, 16);
							s += CString(buf);
						}
					}
					Attrib.SequenceValue.clear();
					AfxMessageBox(_T("Sequence: ") + s);
					break;
				case atString:
					AfxMessageBox(_T("String: ") + CString(Attrib.StringValue.c_str()));
					break;
			}
		}
	}
}

void CIrDADiscoveryDlg::OnBnClickedButtonSubscribe()
{
	int Res = wclIrDAReceiver.Subscribe();
	if (Res != WCL_E_SUCCESS)
		ShowError(Res);
}

void CIrDADiscoveryDlg::OnBnClickedButtonUnsubscribe()
{
	int Res = wclIrDAReceiver.Unsubscribe();
	if (Res != WCL_E_SUCCESS)
		ShowError(Res);
}

void CIrDADiscoveryDlg::OnBnClickedButtonClear()
{
	lbEvents.ResetContent();
}

void CIrDADiscoveryDlg::OnBnClickedButtonStartLazyDiscovering()
{
	int Res = wclIrDAReceiver.StartLazyDiscovering();
	if (Res != WCL_E_SUCCESS)
		ShowError(Res);
}

void CIrDADiscoveryDlg::OnBnClickedButtonStopLazyDiscovering()
{
	int Res = wclIrDAReceiver.StopLazyDiscovering();
	if (Res != WCL_E_SUCCESS)
		ShowError(Res);
}

void CIrDADiscoveryDlg::wclIrDAReceiverChange(void* Sender)
{
	UNREFERENCED_PARAMETER(Sender);

	if (wclIrDAReceiver.Available)
		lbEvents.InsertString(lbEvents.GetCount(), _T("Hardware changed. IrDA available."));
	else
		lbEvents.InsertString(lbEvents.GetCount(), _T("Hardware changed. IrDA NOT available."));
}

void CIrDADiscoveryDlg::wclIrDAReceiverDevicesFound(void* Sender, const wclIrDADevice& Device)
{
	UNREFERENCED_PARAMETER(Sender);

	CString s;
	s.Format(_T("Device found: %.8X ; %s"), Device.Address, Device.Name.c_str());
	lbEvents.InsertString(lbEvents.GetCount(), s);
}

void CIrDADiscoveryDlg::OnDestroy()
{
	CDialog::OnDestroy();

	wclIrDAReceiver.StopLazyDiscovering();
	wclIrDAReceiver.Unsubscribe();

	FPowerMonitor.Close();

	__unhook(&wclIrDAReceiver);
	__unhook(&FPowerMonitor);
}

void CIrDADiscoveryDlg::PowerStateChanged(void* Sender, const wclPowerState State)
{
	UNREFERENCED_PARAMETER(Sender);

	switch (State)
	{
		case psResumeAutomatic:
			lbEvents.InsertString(lbEvents.GetCount(), _T("Power state: psResumeAutomatic"));
			break;

		case psResume:
			lbEvents.InsertString(lbEvents.GetCount(), _T("Power state: psResume"));
			break;

		case psSuspend:
			wclIrDAReceiver.StopLazyDiscovering();
			wclIrDAReceiver.Unsubscribe();
			
			lbEvents.InsertString(lbEvents.GetCount(), _T("Power state: psSuspend"));
			break;

		case psUnknown:
			lbEvents.InsertString(lbEvents.GetCount(), _T("Power state: psUnknown"));
			break;
	}
}