// IrDADiscoveryDlg.h : header file
//

#pragma once
#include "afxcmn.h"
#include "afxwin.h"

#include "..\..\..\Source\Common\wclErrors.h"
#include "..\..\..\Source\Common\wclPowerEvents.h"
#include "..\..\..\Source\IrDA\wclIrDADevices.h"

using namespace wclCommon;
using namespace wclIrDA;

// CIrDADiscoveryDlg dialog
class CIrDADiscoveryDlg : public CDialog
{
// Construction
public:
	CIrDADiscoveryDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_IRDADISCOVERY_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

private:
	CListCtrl lvDevices;
	CComboBox cbClassName;
	CComboBox cbAttributeName;
	CListBox lbEvents;

	void ShowError(const int Error) const;

	CwclIrDAReceiver wclIrDAReceiver;
	CwclPowerEventsMonitor FPowerMonitor;

	void wclIrDAReceiverChange(void* Sender);
	void wclIrDAReceiverDevicesFound(void* Sender, const wclIrDADevice& Device);

	void PowerStateChanged(void* Sender, const wclPowerState State);

public:
	afx_msg void OnCbnCloseupComboClassName();
	afx_msg void OnBnClickedButtonDiscover();
	afx_msg void OnBnClickedButtonQuery();
	afx_msg void OnBnClickedButtonSubscribe();
	afx_msg void OnBnClickedButtonUnsubscribe();
	afx_msg void OnBnClickedButtonClear();
	afx_msg void OnBnClickedButtonStartLazyDiscovering();
	afx_msg void OnBnClickedButtonStopLazyDiscovering();
	afx_msg void OnDestroy();
};
