// IrDAServerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "IrDAServer.h"
#include "IrDAServerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CIrDAServerDlg dialog




CIrDAServerDlg::CIrDAServerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CIrDAServerDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CIrDAServerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_CLIENTS, lvClients);
	DDX_Control(pDX, IDC_EDIT_TEXT, edText);
	DDX_Control(pDX, IDC_LIST_EVENTS, lbEvents);
	DDX_Control(pDX, IDC_EDIT_READ_BUFFER, edReadBuffer);
	DDX_Control(pDX, IDC_EDIT_WRITE_BUFFER, edWriteBuffer);
	DDX_Control(pDX, IDC_COMBO_IAS_VALUE_TYPE, cbIasValueType);
}

BEGIN_MESSAGE_MAP(CIrDAServerDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_LISTEN, &CIrDAServerDlg::OnBnClickedButtonListen)
	ON_BN_CLICKED(IDC_BUTTON_CLOSE, &CIrDAServerDlg::OnBnClickedButtonClose)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, &CIrDAServerDlg::OnBnClickedButtonClear)
	ON_BN_CLICKED(IDC_BUTTON_DISCONNECT, &CIrDAServerDlg::OnBnClickedButtonDisconnect)
	ON_BN_CLICKED(IDC_BUTTON_SEND, &CIrDAServerDlg::OnBnClickedButtonSend)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_GET, &CIrDAServerDlg::OnBnClickedButtonGet)
	ON_BN_CLICKED(IDC_BUTTON_SET, &CIrDAServerDlg::OnBnClickedButtonSet)
	ON_BN_CLICKED(IDC_BUTTON_ADD_RECORD, &CIrDAServerDlg::OnBnClickedButtonAddRecord)
END_MESSAGE_MAP()


// CIrDAServerDlg message handlers

BOOL CIrDAServerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	lvClients.InsertColumn(0, _T("Address"), 0, 200);
	lvClients.InsertColumn(1, _T("Name"), 0, 200);
	lvClients.SetExtendedStyle(lvClients.GetExtendedStyle() | LVS_EX_FULLROWSELECT);

	edText.SetWindowText(_T("Send this text to selected client"));

	edReadBuffer.SetWindowText(_T(""));
	edWriteBuffer.SetWindowText(_T(""));

	cbIasValueType.InsertString(0, _T("Integer"));
	cbIasValueType.InsertString(1, _T("Octet sequence"));
	cbIasValueType.InsertString(2, _T("ASCII string"));
	cbIasValueType.SetCurSel(0);

	__hook(&CwclIrDAServer::OnClosed, &wclIrDAServer, &CIrDAServerDlg::wclIrDAServerClosed);
	__hook(&CwclIrDAServer::OnListen, &wclIrDAServer, &CIrDAServerDlg::wclIrDAServerListen);
	__hook(&CwclIrDAServer::OnConnect, &wclIrDAServer, &CIrDAServerDlg::wclIrDAServerConnect);
	__hook(&CwclIrDAServer::OnDisconnect, &wclIrDAServer, &CIrDAServerDlg::wclIrDAServerDisconnect);
	__hook(&CwclIrDAServer::OnData, &wclIrDAServer, &CIrDAServerDlg::wclIrDAServerData);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CIrDAServerDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CIrDAServerDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CIrDAServerDlg::ShowError(const int Error) const
{
	CString s;
	s.Format(_T("Error: 0x%.8X"), Error);
	AfxMessageBox(s);
}
void CIrDAServerDlg::OnBnClickedButtonListen()
{
	int Res = wclIrDAServer.Listen();
	if (Res != WCL_E_SUCCESS)
		ShowError(Res);
}

void CIrDAServerDlg::OnBnClickedButtonClose()
{
	int Res = wclIrDAServer.Close();
	if (Res != WCL_E_SUCCESS)
		ShowError(Res);
}

void CIrDAServerDlg::OnBnClickedButtonClear()
{
	lbEvents.ResetContent();
}

void CIrDAServerDlg::OnBnClickedButtonDisconnect()
{
	POSITION Pos = lvClients.GetFirstSelectedItemPosition();
	if (Pos == NULL)
		AfxMessageBox(_T("Select client"));
	else
	{
		int Res = ((CwclIrDAServerClientConnection*)lvClients.GetItemData(lvClients.GetNextSelectedItem(Pos)))->Disconnect();
		if (Res != WCL_E_SUCCESS)
			ShowError(Res);
	}
}

void CIrDAServerDlg::OnBnClickedButtonSend()
{
	POSITION Pos = lvClients.GetFirstSelectedItemPosition();
	if (Pos == NULL)
		AfxMessageBox(_T("Select client"));
	else
	{
		CString Text;
		edText.GetWindowText(Text);
		CStringA Ansi(Text);
		unsigned long Sent = 0;
		int Res = ((CwclIrDAServerClientConnection*)lvClients.GetItemData(lvClients.GetNextSelectedItem(Pos)))->Write(
			Ansi.GetBuffer(), Ansi.GetLength(), Sent);
		if (Res != WCL_E_SUCCESS)
			ShowError(Res);
		else
		{
			Text.Format(_T("Send: %d from %d"), Sent, Ansi.GetLength());
			AfxMessageBox(Text);
		}
	}
}

void CIrDAServerDlg::wclIrDAServerClosed(void* Sender, const int Reason)
{
	UNREFERENCED_PARAMETER(Sender);

	CString s;
	s.Format(_T("Server closed: 0x%.8X"), Reason);
	lbEvents.AddString(s);
	lvClients.DeleteAllItems();
	
	edReadBuffer.SetWindowText(_T(""));
	edWriteBuffer.SetWindowText(_T(""));
}

void CIrDAServerDlg::wclIrDAServerListen(void* Sender)
{
	UNREFERENCED_PARAMETER(Sender);

	lbEvents.AddString(_T("Server listening"));
}

void CIrDAServerDlg::wclIrDAServerConnect(void* Sender, CwclIrDAServerClientConnection* const Client, 
	const int Error)
{
	UNREFERENCED_PARAMETER(Sender);

	CString s;
	s.Format(_T("Client connected: %.8X error: 0x%.8X"), Client->Address, Error);
	lbEvents.AddString(s);
	int i = lvClients.GetItemCount();
	s.Format(_T("%.8X"), Client->Address);
	lvClients.InsertItem(i, s);
	lvClients.SetItemText(i, 1, Client->Name.c_str());
	lvClients.SetItemData(i, (DWORD_PTR)Client);
}

void CIrDAServerDlg::wclIrDAServerDisconnect(void* Sender, CwclIrDAServerClientConnection* const Client, 
	const int Reason)
{
	UNREFERENCED_PARAMETER(Sender);

	CString s;
	s.Format(_T("Client disconnected: %.8X reason 0x%.8X"), Client->Address, Reason);
	lbEvents.AddString(s);
	for (int i = 0; i < lvClients.GetItemCount(); i++)
	{
		if (lvClients.GetItemData(i) == (DWORD_PTR)Client)
		{
			lvClients.DeleteItem(i);
			break;
		}
	}
}

void CIrDAServerDlg::wclIrDAServerData(void* Sender, CwclIrDAServerClientConnection* const Client,
	const void* const Data, const unsigned long Size)
{
	UNREFERENCED_PARAMETER(Sender);

	if (Size > 0)
	{
		CStringA Str((PCHAR)Data, Size);
		CString StrW(Str);
		CString a;
		a.Format(_T("Received: %s from %.8X"), static_cast<LPCWSTR>(StrW), Client->Address);
		lbEvents.AddString(a);
	}
}
void CIrDAServerDlg::OnDestroy()
{
	CDialog::OnDestroy();

	wclIrDAServer.Close();

	__unhook(&wclIrDAServer);
}

void CIrDAServerDlg::OnBnClickedButtonGet()
{
	POSITION Pos = lvClients.GetFirstSelectedItemPosition();
	if (Pos == NULL)
		AfxMessageBox(_T("Select client"));
	else
	{
		CString s;
		CwclIrDAServerClientConnection* Client =(CwclIrDAServerClientConnection*)lvClients.GetItemData(lvClients.GetNextSelectedItem(Pos));
		
		// Get read buffer.
		unsigned long Size = 0;
		int Res = Client->GetReadBufferSize(Size);
		if (Res != WCL_E_SUCCESS)
		{
			s.Format(_T("Get read buffer error: 0x%.8X"), Res);
			lbEvents.AddString(s);
		}
		else
		{
			s.Format(_T("%d"), Size);
			edReadBuffer.SetWindowText(s);
		}
		
		// Get write buffer.
		Size = 0;
		Res = Client->GetWriteBufferSize(Size);
		if (Res != WCL_E_SUCCESS)
		{
			s.Format(_T("Get write buffer error: 0x%.8X"), Res);
			lbEvents.AddString(s);
		}
		else
		{
			s.Format(_T("%d"), Size);
			edWriteBuffer.SetWindowText(s);
		}
	}
}

void CIrDAServerDlg::OnBnClickedButtonSet()
{
	POSITION Pos = lvClients.GetFirstSelectedItemPosition();
	if (Pos == NULL)
		AfxMessageBox(_T("Select client"));
	else
	{
		CString s;
		CwclIrDAServerClientConnection* Client =(CwclIrDAServerClientConnection*)lvClients.GetItemData(lvClients.GetNextSelectedItem(Pos));
		
		// Set read buffer.
		edReadBuffer.GetWindowText(s);
		unsigned long Size = _ttoi(s);
		int Res = Client->SetReadBufferSize(Size);
		if (Res != WCL_E_SUCCESS)
		{
			s.Format(_T("Set read buffer error: 0x%.8X"), Res);
			lbEvents.AddString(s);
		}
		
		// Set write buffer.
		edWriteBuffer.GetWindowText(s);
		Size = _ttoi(s);
		Res = Client->SetWriteBufferSize(Size);
		if (Res != WCL_E_SUCCESS)
		{
			s.Format(_T("Set write buffer error: 0x%.8X"), Res);
			lbEvents.AddString(s);
		}
	}
}

void CIrDAServerDlg::OnBnClickedButtonAddRecord()
{
	CString s;
	switch (cbIasValueType.GetCurSel())
	{
		case 0:
			{
				int Res = wclIrDAServer.AddIasRecord(_T("IrDAFramework"), _T("Integer value"),
					1234567);
				if (Res != WCL_E_SUCCESS)
				{
					s.Format(_T("Add IAS record error: 0x%.8X"), Res);
					lbEvents.AddString(s);
				}
			}
			break;
		
		case 1:
			{
				unsigned char Arr[8] = { 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08 };
				int Res = wclIrDAServer.AddIasRecord(_T("IrDAFramework"), _T("Octet Sequence"),
					8, Arr);
				if (Res != WCL_E_SUCCESS)
				{
					s.Format(_T("Add IAS record error: 0x%.8X"), Res);
					lbEvents.AddString(s);
				}
			}
			break;

		case 2:
			{
				unsigned char Arr[11] = { 85, 115, 101, 114, 32, 115, 116, 114, 105, 110, 103 };
				int Res = wclIrDAServer.AddIasRecord(_T("IrDAFramework"), _T("User string"),
					csAscii, 11, Arr);
				if (Res != WCL_E_SUCCESS)
				{
					s.Format(_T("Add IAS record error: 0x%.8X"), Res);
					lbEvents.AddString(s);
				}
			}
			break;
	}
}
