// IrDAServerDlg.h : header file
//

#pragma once
#include "afxcmn.h"
#include "afxwin.h"

#include "..\..\..\Source\IrDA\wclIrDAServers.h"

using namespace wclCommon;
using namespace wclIrDA;


// CIrDAServerDlg dialog
class CIrDAServerDlg : public CDialog
{
// Construction
public:
	CIrDAServerDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_IRDASERVER_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

private:
	CListCtrl lvClients;
	CEdit edText;
	CListBox lbEvents;
	CEdit edReadBuffer;
	CEdit edWriteBuffer;

	CwclIrDAServer wclIrDAServer;

	void ShowError(const int Error) const;

	void wclIrDAServerClosed(void* Sender, const int Reason);
	void wclIrDAServerListen(void* Sender);
	void wclIrDAServerConnect(void* Sender, CwclIrDAServerClientConnection* const Client,
		const int Error);
	void wclIrDAServerDisconnect(void* Sender, CwclIrDAServerClientConnection* const Client,
		const int Reason);
	void wclIrDAServerData(void* Sender, CwclIrDAServerClientConnection* const Client,
		const void* const Data, const unsigned long Size);

public:
	afx_msg void OnBnClickedButtonListen();
	afx_msg void OnBnClickedButtonClose();
	afx_msg void OnBnClickedButtonClear();
	afx_msg void OnBnClickedButtonDisconnect();
	afx_msg void OnBnClickedButtonSend();
	afx_msg void OnDestroy();
	afx_msg void OnBnClickedButtonGet();
	afx_msg void OnBnClickedButtonSet();
private:
	CComboBox cbIasValueType;
public:
	afx_msg void OnBnClickedButtonAddRecord();
};
