// OppClientDlg.h : header file
//

#pragma once
#include "afxcmn.h"
#include "afxwin.h"

#include "..\..\..\Source\IrDA\wclIrDADevices.h"
#include "..\..\..\Source\IrDA\wclIrDAClients.h"
#include "..\..\..\Source\Communication\wclObex.h"

using namespace wclCommon;
using namespace wclCommunication;
using namespace wclIrDA;


// COppClientDlg dialog
class COppClientDlg : public CDialog
{
// Construction
public:
	COppClientDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_OPPCLIENT_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

private:
	CListCtrl lvDevices;
	CEdit edFileName;
	CProgressCtrl ProgressBar;
	CListBox lbLog;
	
	CwclIrDAReceiver wclIrDAReceiver;
	CwclIrDAClient wclIrDAClient;

	CwclObexOppClient* FOpp;

	void ClientDisconnect(void* Sender, const int Reason);
	void ClientConnect(void* Sender, const int Error);
	void ClientDestroyProcessor(void* Sender, CwclClientDataConnection* const Connection);
	void ClientCreateProcessor(void* Sender, CwclClientDataConnection* const Connection);

	void OppConnect(void* Sender, const int Error, const tstring& Description);
	void OppDisconnect(void* Sender, const int Error, const tstring& Description);
	void OppPutComplete(void* Sender, const int Error, const tstring& Description, 
		CwclStream* const Stream);
	void OppProgress(void* Sender, const unsigned long Size, const unsigned long Position);
	void OppGetComplete(void* Sender, const int Error, const tstring& Description, 
		CwclStream* const Stream);

public:
	afx_msg void OnBnClickedButtonClear();
	afx_msg void OnDestroy();
	afx_msg void OnBnClickedButtonDiscover();
	afx_msg void OnBnClickedButtonDisconnect();
	afx_msg void OnBnClickedButtonCloseSession();
	afx_msg void OnBnClickedButtonOpenSession();
	afx_msg void OnBnClickedButtonConnect();
	afx_msg void OnBnClickedButtonAbort();
	afx_msg void OnBnClickedButtonSendFile();
	afx_msg void OnBnClickedButtonGetVcard();
	afx_msg void OnBnClickedButtonGetCaps();
	afx_msg void OnBnClickedButtonSelectFile();
};
