// OppServerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "OppServer.h"
#include "OppServerDlg.h"

#include "..\..\..\Source\Common\wclErrors.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// COppServerDlg dialog

CString IntToHex(const int i)
{
	CString s;
	s.Format(_T("%.8X"), i);
	return s;
}

CString IntToStr(const int i)
{
	CString s;
	s.Format(_T("%d"), i);
	return s;
}


COppServerDlg::COppServerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COppServerDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void COppServerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_LOG, lbLog);
}

BEGIN_MESSAGE_MAP(COppServerDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, &COppServerDlg::OnBnClickedButtonClear)
	ON_BN_CLICKED(IDC_BUTTON_LISTEN, &COppServerDlg::OnBnClickedButtonListen)
	ON_BN_CLICKED(IDC_BUTTON_CLOSE, &COppServerDlg::OnBnClickedButtonClose)
	ON_WM_DESTROY()
END_MESSAGE_MAP()


// COppServerDlg message handlers

BOOL COppServerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	wclIrDAServer.Service = _T("OBEX");
	wclIrDAServer.Mode = cmIrComm3Wire; // Required for OBEX connection!

	__hook(&CwclIrDAServer::OnListen, &wclIrDAServer, &COppServerDlg::wclIrDAServerListen);
	__hook(&CwclIrDAServer::OnClosed, &wclIrDAServer, &COppServerDlg::wclIrDAServerClosed);
	__hook(&CwclIrDAServer::OnDisconnect, &wclIrDAServer, &COppServerDlg::wclIrDAServerDisconnect);
	__hook(&CwclIrDAServer::OnDestroyProcessor, &wclIrDAServer, &COppServerDlg::wclIrDAServerDestroyProcessor);
	__hook(&CwclIrDAServer::OnConnect, &wclIrDAServer, &COppServerDlg::wclIrDAServerConnect);
	__hook(&CwclIrDAServer::OnCreateProcessor, &wclIrDAServer, &COppServerDlg::wclIrDAServerCreateProcessor);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void COppServerDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR COppServerDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void COppServerDlg::OnBnClickedButtonClear()
{
	// TODO: Add your control notification handler code here
	lbLog.ResetContent();
}

void COppServerDlg::Trace(const CString& Msg)
{
	lbLog.AddString(Msg);
}
void COppServerDlg::OnBnClickedButtonListen()
{
	// TODO: Add your control notification handler code here
	int Res = wclIrDAServer.Listen();
	if (Res != WCL_E_SUCCESS)
		AfxMessageBox(_T("Error: 0x") + IntToHex(Res));
}

void COppServerDlg::OnBnClickedButtonClose()
{
	// TODO: Add your control notification handler code here
	int Res = wclIrDAServer.Close();
	if (Res != WCL_E_SUCCESS)
		AfxMessageBox(_T("Error: 0x") + IntToHex(Res));
}

void COppServerDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: Add your message handler code here

	// Simple try to close the server.
	wclIrDAServer.Close();

	__unhook(&wclIrDAServer);
}

void COppServerDlg::wclIrDAServerListen(void* Sender)
{
	UNREFERENCED_PARAMETER(Sender);

	Trace(_T("Server listening"));
}

void COppServerDlg::wclIrDAServerClosed(void* Sender, const int Reason)
{
	UNREFERENCED_PARAMETER(Sender);

	Trace(_T("Server closed. Reason: 0x") + IntToHex(Reason));
}

void COppServerDlg::wclIrDAServerDisconnect(void* Sender, CwclIrDAServerClientConnection* const Client, 
	const int Reason)
{
	UNREFERENCED_PARAMETER(Sender);

	Trace(_T("Client ") + IntToHex(Client->Address) + _T(" disconnected. Reason: 0x") + IntToHex(Reason));
}

void COppServerDlg::wclIrDAServerDestroyProcessor(void* Sender, CwclServerClientDataConnection* const Connection)
{
	UNREFERENCED_PARAMETER(Sender);

	Trace(_T("Data processor for client ") + IntToHex(((CwclIrDAServerClientConnection*)Connection)->Address) +
		_T(" is destroing"));

	__unhook((CwclObexOppServer*)Connection->Processor);
	delete (CwclObexOppServer*)Connection->Processor;
}

void COppServerDlg::wclIrDAServerConnect(void* Sender, CwclIrDAServerClientConnection* const Client, 
	const int Error)
{
	UNREFERENCED_PARAMETER(Sender);

	if (Error == WCL_E_SUCCESS)
		Trace(_T("Client ") + IntToHex(Client->Address) + _T(" connected"));
	else
		Trace(_T("Client ") + IntToHex(Client->Address) + _T(" connect failed: 0x") + IntToHex(Error));
}

void COppServerDlg::wclIrDAServerCreateProcessor(void* Sender, CwclServerClientDataConnection* const Connection)
{
	UNREFERENCED_PARAMETER(Sender);

	// Here we must create OBEX OPP server data processor.
	CwclObexOppServer* Proc = new CwclObexOppServer(Connection);
	__hook(&CwclObexOppServer::OnConnect, Proc, &COppServerDlg::OppClientConnect);
	__hook(&CwclObexOppServer::OnDisconnected, Proc, &COppServerDlg::OppClientDisconnected);
	__hook(&CwclObexOppServer::OnPutBegin, Proc, &COppServerDlg::OppClientPutBegin);
	__hook(&CwclObexOppServer::OnPutCompleted, Proc, &COppServerDlg::OppClientPutCompleted);
	__hook(&CwclObexOppServer::OnPutProgress, Proc, &COppServerDlg::OppClientPutProgress);
}

void COppServerDlg::OppClientConnect(void* Sender, const tstring& Description)
{
	CwclObexOppServer* Proc = (CwclObexOppServer*)Sender;
	unsigned long Address = ((CwclIrDAServerClientConnection*)Proc->Connection)->Address;
	bool Accept = AfxMessageBox(_T("Client ") + IntToHex(Address) +
		_T(" requsts for connection: ") + CString(Description.c_str()) + _T(". Accept?"),
		MB_ICONQUESTION | MB_YESNO) == IDYES;
	
	int Res;
	if (Accept)
		Res = Proc->Accept(_T("Accepted by user"));
	else
		Res = Proc->Reject(_T("Rejected by user"));
	
	if (Res != WCL_E_SUCCESS)
	{
		AfxMessageBox(_T("Operation failed: 0x") + IntToHex(Res));
		// Disconnect client!
		Proc->Connection->Disconnect();
	}
}

void COppServerDlg::OppClientDisconnected(void* Sender, const int Reason, 
	const tstring& Description)
{
	CwclObexOppServer* Proc = (CwclObexOppServer*)Sender;
	unsigned long Address = ((CwclIrDAServerClientConnection*)Proc->Connection)->Address;
	
	Trace(_T("Client ") + IntToHex(Address) + _T(" closed OBEX session with reason: 0x") + IntToHex(Reason) +
		_T(". Description: ") + CString(Description.c_str()));
}

void COppServerDlg::OppClientPutBegin(void* Sender, const tstring& Name, 
	const tstring& Description, const tstring& Mime, const unsigned long Length, bool& Accept)
{
	UNREFERENCED_PARAMETER(Description);
	UNREFERENCED_PARAMETER(Mime);
	UNREFERENCED_PARAMETER(Length);

	CwclObexOppServer* Proc = (CwclObexOppServer*)Sender;
	unsigned long Address = ((CwclIrDAServerClientConnection*)Proc->Connection)->Address;
	CString Str = _T("Client ") + IntToHex(Address) + _T(" send file ") + CString(Name.c_str()) +
		_T(". Accept?");
	Accept = AfxMessageBox(Str, MB_ICONQUESTION | MB_YESNO) == IDYES;
	
	if (Accept)
		FFileName = Name;
}

void COppServerDlg::OppClientPutCompleted(void* Sender, const int Error, CwclStream* const Stream, 
	bool& Accept)
{
	CwclObexOppServer* Proc = (CwclObexOppServer*)Sender;
	unsigned long Address = ((CwclIrDAServerClientConnection*)Proc->Connection)->Address;
	if (Error == WCL_E_SUCCESS)
	{
		CString Str = _T("Client ") + IntToHex(Address) + _T(" completed sent file. Accept?");
		Accept = AfxMessageBox(Str, MB_ICONQUESTION | MB_YESNO) == IDYES;
		
		if (Accept)
		{
			CFileDialog Dlg(FALSE, NULL, FFileName.c_str());
			if (Dlg.DoModal() == IDOK)
			{
				CwclFileStream fs(tstring(Dlg.GetPathName()), CREATE_ALWAYS, GENERIC_WRITE, FILE_SHARE_READ);
				((CwclMemoryStream*)Stream)->SaveToStream(&fs);
			}
		}
	}
	else
		Trace(_T("Send file error: 0x") + IntToHex(Error));
}

void COppServerDlg::OppClientPutProgress(void* Sender, const unsigned long Position,
	const unsigned long Length, bool& Continue)
{
	UNREFERENCED_PARAMETER(Sender);

	Trace(_T("Sending file: ") + IntToStr(Position) + _T(" from ") + IntToStr(Length));
	// Do not foget to set Continue flag!
	Continue = true;
}