// OppServerDlg.h : header file
//

#pragma once
#include "afxwin.h"

#include "..\..\..\Source\IrDA\wclIrDADevices.h"
#include "..\..\..\Source\IrDA\wclIrDAServers.h"
#include "..\..\..\Source\Communication\wclObex.h"

using namespace wclCommon;
using namespace wclCommunication;
using namespace wclIrDA;


// COppServerDlg dialog
class COppServerDlg : public CDialog
{
// Construction
public:
	COppServerDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_OPPSERVER_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

private:
	CListBox lbLog;

	CwclIrDAServer wclIrDAServer;
	tstring FFileName;

	void Trace(const CString& Msg);

	void wclIrDAServerListen(void* Sender);
	void wclIrDAServerClosed(void* Sender, const int Reason);
	void wclIrDAServerDisconnect(void* Sender, CwclIrDAServerClientConnection* const Client, 
		const int Reason);
	void wclIrDAServerDestroyProcessor(void* Sender, CwclServerClientDataConnection* const Connection);
	void wclIrDAServerConnect(void* Sender, CwclIrDAServerClientConnection* const Client, 
		const int Error);
	void wclIrDAServerCreateProcessor(void* Sender, CwclServerClientDataConnection* const Connection);

	void OppClientConnect(void* Sender, const tstring& Description);
	void OppClientDisconnected(void* Sender, const int Reason, const tstring& Description);
	void OppClientPutBegin(void* Sender, const tstring& Name, const tstring& Description, 
		const tstring& Mime, const unsigned long Length, bool& Accept);
	void OppClientPutCompleted(void* Sender, const int Error, CwclStream* const Stream, bool& Accept);
	void OppClientPutProgress(void* Sender, const unsigned long Position,
		const unsigned long Length, bool& Continue);

public:
	afx_msg void OnBnClickedButtonClear();
	afx_msg void OnBnClickedButtonListen();
	afx_msg void OnBnClickedButtonClose();
	afx_msg void OnDestroy();
};
